/*
 *
 *       Density module for HP_DeskJet_400L
 *
 */

#include "global.h"

#define DENSITY 15


void SetDensity(ULONG density_code)
{
        extern struct PrinterData *PD;
        extern struct PrinterExtendedData *PED;
        extern char StartCmd[];

        /* SPECIAL_DENSITY     0   1   2    3    4    5    6    7 */
        static int XDPI[8] = {75, 75, 150, 150, 150, 300, 300, 300};
        static char codes[8][3] = {
        {'0','7','5'},{'0','7','5'},{'1','5','0'},{'1','5','0'},
        {'1','5','0'},{'3','0','0'},{'3','0','0'},{'3','0','0'},
        };

        PED->ped_MaxColumns =
                PD->pd_Preferences.PaperSize == W_TRACTOR ? 136 : 80;

        density_code /= SPECIAL_DENSITY1;
        PED->ped_MaxXDots = (XDPI[density_code] * PED->ped_MaxColumns) / 10; 

        /* David Berezowski - April 22/90 */
        /* default is 10.0, US_LEGAL is 14.0 */
        PED->ped_MaxYDots =
                PD->pd_Preferences.PaperSize == US_LEGAL ? 14 : 10;
        PED->ped_MaxYDots *= XDPI[density_code];

        PED->ped_XDotsInch = PED->ped_YDotsInch = XDPI[density_code];

        StartCmd[DENSITY] = codes[density_code][0];
        StartCmd[DENSITY+1] = codes[density_code][1];
        StartCmd[DENSITY+2] = codes[density_code][2];
}
